type constante =
   Bool of bool
 | Int of int
 | Float of float
 | String of string
 | Char of char
 | Indefini
 | Nom of string
 | Unit
;;

type primitive =
   Plus
 | Fois
 | Moins
 | Divise
 | Egal
 | Affiche
;;

type expr =
   App of expr * expr
 | Abs of string * expr
 | Var of string
 | Cst of constante
 | If of expr * expr *expr
 | Set of string * expr
 | LetIn of string list * expr list * expr
 | LetRecIn of string list * expr list * expr
 | Prim of primitive
;;

let COMPTEUR =
  ref(0)
;;

let nouvel_entier () =
  incr COMPTEUR;
  !COMPTEUR
;;

let nouveau_nom () =
  "x"^(string_of_int (nouvel_entier ()))
;;

