{
#open "parseur_scheme";;
}

rule Token = parse
    [` ` `\t` `\n`]		{ Token lexbuf }
  | `(`				{ LPAR }
  | `)`				{ RPAR }
  | `.`				{ DOT }  
  | `'`				{ QUOTE }
  | `\``			{ BACKQUOTE }
  | `,`				{ COMMA }
  | ",@"			{ COMMAAT }
  | `-`? [`0`-`9`]+ `.` [`0`-`9`]* ([`e` `E`] [`+` `-`]? [`0`-`9`]+)?
      	       	       	       	{ FLOAT (float_of_string (get_lexeme lexbuf)) }
  | `-`? [`0`-`9`]+		{ INT (int_of_string (get_lexeme lexbuf)) }
  | [^ `(` `)` `\\` `.` `,` `'` `\`` ` ` `\t` `\n` `"` `#`]
    [^ `(` `)` `\\` `.` `,` `'` `\`` ` ` `\t` `\n` `"`]*
      	       	       	       	{ SYMBOL (get_lexeme lexbuf) }
  | `#` `\\` _			{ CHAR (get_lexeme_char lexbuf 2) }
  | "#!null"			{ NIL }
  | "#!false"			{ NIL }
  | "#!true"		       	{ TRUE }
  | `#` [`f` `F`]		{ NIL }
  | `#` [`t` `T`]		{ TRUE }
  | `"`				{ try STRING (Chaine lexbuf)
                                  with End_of_file -> EOF }
  | eof 			{ EOF }

and Chaine = parse
    `"`				{ "" }
  | `\\` `\\`			{ "\\"^(Chaine lexbuf) }
  | `\\` `n`			{ "\n"^(Chaine lexbuf) }
  | `\\` `"`			{ "\""^(Chaine lexbuf) }
  | `\\` `t`			{ "\t"^(Chaine lexbuf) }
  | `\\` `b`			{ "\b"^(Chaine lexbuf) }
  | _                           { let s=(get_lexeme lexbuf)
                                  in s^(Chaine lexbuf) }
  | eof				{ raise End_of_file }
;;

